package users

import (
	"context"
	"net/http"

	"acooldomain.co/backend/auth"
	"github.com/gin-gonic/gin"
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/mongo"
)

type User struct {
	Username        string          `json:"username"`
	Email           string          `json:"email"`
	MaxOwnedServers int             `json:"maxed_owned_servers"`
	Permissions     auth.Permission `json:"permissions"`
	HashedPass      auth.Permission `json:"hashedPass"`
}

type Connection struct {
	connection *mongo.Client
}

func (con Connection) GetUsers(c *gin.Context) {
	users, err := con.connection.Database("Backend").Collection("Users").Find(context.TODO(), bson.D{})
	if err != nil {
		panic(err)
	}
	var response []User

	err = users.All(context.TODO(), &response)

	if err != nil {
		panic(err)
	}

	c.IndentedJSON(http.StatusOK, response)
}

func LoadGroup(group *gin.RouterGroup, client *mongo.Client) {
	connection := Connection{connection: client}
	group.Use(auth.AuthorizedTo(0)).GET("/", connection.GetUsers)
}
